#include <iostream>
#include <vector>
#include <string>

using namespace std;

struct lab_t {
    int monitors;
    int desks;
    vector<int> neighbours;
    vector<int> updatedNeighbours;
    int updatedBy;
};

int main() {
    int noLabs, noPairs, noQueries;
    cin >> noLabs >> noPairs >> noQueries;

    vector<lab_t> labs (noLabs);

    for (int i = 0; i < noLabs; i++) {
        labs[i].neighbours.clear();
        labs[i].updatedBy = 0;
        labs[i].updatedNeighbours.clear();
        cin >> labs[i].desks;
    }

    for (int i = 0; i < noLabs; i++) {
        cin >> labs[i].monitors;
    }

    for (int i = 0; i < noPairs; i++) {
        int lab1, lab2;
        cin >>lab1 >> lab2;

        lab1--;
        lab2--;
        labs[lab1].neighbours.push_back(lab2);
        labs[lab2].neighbours.push_back(lab1);
    }

    for (int query = 0; query < noQueries; query++) {
        string cmd;
        cin >> cmd;

        if (cmd == "add"s) {
            int count, lab;
            string type;
            cin >> count >> type >> lab;
            lab--;

            if (type == "desk"s) {
                labs[lab].desks += count;
            } else if (type == "monitor"s) {
                labs[lab].monitors += count;
            }

            if (!labs[lab].updated) {
                for (int neighbour: labs[lab].neighbours) {
                    labs[neighbour].updatedNeighbours.push_back(lab);
                }
                labs[lab].updatedBy += count
            }
        } else if (cmd == "check"s) {
            int lab;
            cin >> lab;

            lab--;

            int totalDesks = labs[lab].desks;
            int totalMonitors = labs[lab].monitors;

            for (int i : labs[lab].updatedNeighbours) {
                totalDesks += labs[i].desks;
                totalMonitors += labs[i].monitors;
            }

            if (totalDesks > totalMonitors) {
                cout << "desks" << endl;
            } else if (totalDesks < totalMonitors) {
                cout << "monitors" << endl;
            } else {
                cout << "same" << endl;
            }
        }
    }
    return 0;
}
